Index: trunk/lib/FlairSensorActuator/src/Gps.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gps.cpp	(revision 14)
+++ trunk/lib/FlairSensorActuator/src/Gps.cpp	(revision 15)
@@ -38,303 +38,254 @@
 using namespace flair::gui;
 
-namespace flair
-{
-namespace sensor
-{
-
-Gps::Gps(const FrameworkManager* parent,string name,NMEAFlags_t NMEAFlags) : IODevice(parent,name)
-{
-    this->NMEAFlags=NMEAFlags;
-
-    nmea_zero_INFO(&info);
-    nmea_parser_init(&parser);
-    alt_ref=0;
-
-
-    if((NMEAFlags&GGA)==0)
+namespace flair {
+namespace sensor {
+
+Gps::Gps(const FrameworkManager *parent, string name, NMEAFlags_t NMEAFlags)
+    : IODevice(parent, name) {
+  this->NMEAFlags = NMEAFlags;
+
+  nmea_zero_INFO(&info);
+  nmea_parser_init(&parser);
+  alt_ref = 0;
+
+  if ((NMEAFlags & GGA) == 0) {
+    Err("Enable at least GGA sentence\n");
+  }
+
+  int index = 0;
+  if ((NMEAFlags & GGA) != 0) {
+    index += 3;
+  }
+  if ((NMEAFlags & VTG) != 0) {
+    index += 2;
+  }
+  if ((NMEAFlags & GST) != 0) {
+    index += 3;
+  }
+
+  cvmatrix_descriptor *desc = new cvmatrix_descriptor(index, 1);
+  index = 0;
+  if ((NMEAFlags & GGA) != 0) {
+    desc->SetElementName(0, 0, "e");
+    desc->SetElementName(1, 0, "n");
+    desc->SetElementName(2, 0, "u");
+    index += 3;
+  }
+  if ((NMEAFlags & VTG) != 0) {
+    desc->SetElementName(index, 0, "ve");
+    desc->SetElementName(index + 1, 0, "vn");
+    index += 2;
+  }
+  if ((NMEAFlags & GST) != 0) {
+    desc->SetElementName(index, 0, "dev_lat");
+    desc->SetElementName(index + 1, 0, "dev_lon");
+    desc->SetElementName(index + 2, 0, "dev_elv");
+    index += 3;
+  }
+  output = new cvmatrix((IODevice *)this, desc, floatType);
+  AddDataToLog(output);
+
+  // station sol
+  main_tab = new Tab(parent->GetTabWidget(), name);
+  tab = new TabWidget(main_tab->NewRow(), name);
+  sensor_tab = new Tab(tab, "Reglages");
+  GroupBox *reglages_groupbox = new GroupBox(sensor_tab->NewRow(), name);
+  button_ref = new PushButton(reglages_groupbox->NewRow(), "set ref");
+  nb_sat_label = new Label(reglages_groupbox->NewRow(), "nb_sat");
+  fix_label = new Label(reglages_groupbox->LastRowLastCol(), "fix");
+
+  position = new GeoCoordinate((IODevice *)this, "position", 0, 0, 0);
+
+  fix = FixQuality_t::Invalid;
+  nb_sat = 0;
+  take_ref = false;
+  nb_sat_label->SetText("nb_sat: %i", nb_sat);
+  fix_label->SetText("fix: %i", fix);
+}
+
+Gps::~Gps() {
+  nmea_parser_destroy(&parser);
+  delete main_tab;
+}
+
+void Gps::UseDefaultPlot(void) {
+  int index = 0;
+  plot_tab = new Tab(tab, "Mesures");
+
+  if ((NMEAFlags & GGA) != 0) {
+    e_plot = new DataPlot1D(plot_tab->NewRow(), "e", -10, 10);
+    e_plot->AddCurve(output->Element(index));
+    n_plot = new DataPlot1D(plot_tab->LastRowLastCol(), "n", -10, 10);
+    n_plot->AddCurve(output->Element(index + 1));
+    u_plot = new DataPlot1D(plot_tab->LastRowLastCol(), "u", -10, 10);
+    u_plot->AddCurve(output->Element(index + 2));
+    index += 3;
+  }
+  if ((NMEAFlags & VTG) != 0) {
+    ve_plot = new DataPlot1D(plot_tab->NewRow(), "ve", -10, 10);
+    ve_plot->AddCurve(output->Element(index));
+    vn_plot = new DataPlot1D(plot_tab->LastRowLastCol(), "vn", -10, 10);
+    vn_plot->AddCurve(output->Element(index + 1));
+    index += 2;
+  }
+
+  Tab *map_tab = new Tab(tab, "carte");
+  map = new Map(map_tab->NewRow(), "map");
+  map->AddPoint(position, "drone");
+}
+
+DataPlot1D *Gps::EPlot(void) const {
+  if ((NMEAFlags & GGA) != 0) {
+    return e_plot;
+  } else {
+    Err("GGA sentence not requested\n");
+    return NULL;
+  }
+}
+
+DataPlot1D *Gps::NPlot(void) const {
+  if ((NMEAFlags & GGA) != 0) {
+    return n_plot;
+  } else {
+    Err("GGA sentence not requested\n");
+    return NULL;
+  }
+}
+
+DataPlot1D *Gps::UPlot(void) const {
+  if ((NMEAFlags & GGA) != 0) {
+    return u_plot;
+  } else {
+    Err("GGA sentence not requested\n");
+    return NULL;
+  }
+}
+
+DataPlot1D *Gps::VEPlot(void) const {
+  if ((NMEAFlags & VTG) != 0) {
+    return ve_plot;
+  } else {
+    Err("GGA sentence not requested\n");
+    return NULL;
+  }
+}
+
+DataPlot1D *Gps::VNPlot(void) const {
+  if ((NMEAFlags & VTG) != 0) {
+    return vn_plot;
+  } else {
+    Err("GGA sentence not requested\n");
+    return NULL;
+  }
+}
+
+Layout *Gps::GetLayout(void) const { return sensor_tab; }
+
+Tab *Gps::GetPlotTab(void) const { return plot_tab; }
+
+TabWidget *Gps::GetTab(void) const { return tab; }
+
+uint16_t Gps::NbSat(void) const {
+  output->GetMutex();
+  uint16_t result = nb_sat;
+  output->ReleaseMutex();
+  return result;
+}
+
+Gps::FixQuality_t Gps::FixQuality(void) const {
+  output->GetMutex();
+  FixQuality_t result = fix;
+  output->ReleaseMutex();
+  return result;
+}
+
+void Gps::SetRef(void) { take_ref = true; }
+
+void Gps::GetENUPosition(Vector3D *point) {
+  output->GetMutex();
+  point->x = output->ValueNoMutex(0, 0);
+  point->y = output->ValueNoMutex(1, 0);
+  point->z = output->ValueNoMutex(2, 0);
+  output->ReleaseMutex();
+}
+
+void Gps::parseFrame(const char *frame, int frame_size) {
+
+  int result;
+
+  result = nmea_parse(&parser, frame, frame_size, &info);
+  if (result != 1) {
+    Warn("unrecognized nmea sentence\n");
+    Warn("%s\n", frame);
+  }
+
+  result = nmea_parse_GPGGA(frame, frame_size, &pack);
+
+  if (result == 1) {
+    // Printf("%s\n",frame);
+    // Printf("nb:%i fix:%i lat:%f long:%f alt:%f vel:%f
+    // angle:%f\n",pack.satinuse,pack.sig,info.lat,info.lon,info.elv,info.speed*1000./3600.,info.direction);
+    // Printf("lat:%f long:%f\n",pos.lat,pos.lon);
+    output->GetMutex(); // on utilise le mutex de l'output pour fix et nb_sat
+    if ((int)fix != pack.sig) {
+      fix = (FixQuality_t)pack.sig;
+      fix_label->SetText("fix: %i", fix);
+    }
+    if (nb_sat != pack.satinuse) {
+      nb_sat = pack.satinuse;
+      nb_sat_label->SetText("nb_sat: %i", nb_sat);
+    }
+    output->ReleaseMutex();
+
+    nmea_info2pos(&info, &pos);
+    position->SetCoordinates(Euler::ToDegree(pos.lat), Euler::ToDegree(pos.lon),
+                             info.elv);
+
+    if ((info.sig == 2 && alt_ref == 0) || button_ref->Clicked() == true ||
+        take_ref == true) {
+      Printf("prise pos ref\n");
+      lat_ref = pos.lat;
+      long_ref = pos.lon;
+      alt_ref = info.elv;
+      take_ref = false;
+    }
+    // if(alt_ref!=0)
     {
-        Err("Enable at least GGA sentence\n");
-    }
-
-    int index=0;
-    if((NMEAFlags&GGA)!=0)
-    {
-        index+=3;
-    }
-    if((NMEAFlags&VTG)!=0)
-    {
-        index+=2;
-    }
-    if((NMEAFlags&GST)!=0)
-    {
-        index+=3;
-    }
-
-    cvmatrix_descriptor* desc=new cvmatrix_descriptor(index,1);
-    index=0;
-    if((NMEAFlags&GGA)!=0)
-    {
-        desc->SetElementName(0,0,"e");
-        desc->SetElementName(1,0,"n");
-        desc->SetElementName(2,0,"u");
-        index+=3;
-    }
-    if((NMEAFlags&VTG)!=0)
-    {
-        desc->SetElementName(index,0,"ve");
-        desc->SetElementName(index+1,0,"vn");
-        index+=2;
-    }
-    if((NMEAFlags&GST)!=0)
-    {
-        desc->SetElementName(index,0,"dev_lat");
-        desc->SetElementName(index+1,0,"dev_lon");
-        desc->SetElementName(index+2,0,"dev_elv");
-        index+=3;
-    }
-    output=new cvmatrix((IODevice*)this,desc,floatType);
-    AddDataToLog(output);
-
-    //station sol
-    main_tab=new Tab(parent->GetTabWidget(),name);
-    tab=new TabWidget(main_tab->NewRow(),name);
-	sensor_tab=new Tab(tab,"Reglages");
-	GroupBox* reglages_groupbox=new GroupBox(sensor_tab->NewRow(),name);
-        button_ref=new PushButton(reglages_groupbox->NewRow(),"set ref");
-        nb_sat_label=new Label(reglages_groupbox->NewRow(),"nb_sat");
-        fix_label=new Label(reglages_groupbox->LastRowLastCol(),"fix");
-
-    position=new GeoCoordinate((IODevice*)this,"position",0,0,0);
-
-    fix=FixQuality_t::Invalid;
-    nb_sat=0;
-    take_ref=false;
-    nb_sat_label->SetText("nb_sat: %i",nb_sat);
-    fix_label->SetText("fix: %i",fix);
-}
-
-Gps::~Gps()
-{
-    nmea_parser_destroy(&parser);
-    delete main_tab;
-}
-
-void Gps::UseDefaultPlot(void)
-{
-    int index=0;
-    plot_tab=new Tab(tab,"Mesures");
-
-    if((NMEAFlags&GGA)!=0)
-    {
-        e_plot=new DataPlot1D(plot_tab->NewRow(),"e",-10,10);
-            e_plot->AddCurve(output->Element(index));
-        n_plot=new DataPlot1D(plot_tab->LastRowLastCol(),"n",-10,10);
-            n_plot->AddCurve(output->Element(index+1));
-        u_plot=new DataPlot1D(plot_tab->LastRowLastCol(),"u",-10,10);
-            u_plot->AddCurve(output->Element(index+2));
-        index+=3;
-    }
-    if((NMEAFlags&VTG)!=0)
-    {
-        ve_plot=new DataPlot1D(plot_tab->NewRow(),"ve",-10,10);
-            ve_plot->AddCurve(output->Element(index));
-        vn_plot=new DataPlot1D(plot_tab->LastRowLastCol(),"vn",-10,10);
-            vn_plot->AddCurve(output->Element(index+1));
-        index+=2;
-    }
-
-    Tab* map_tab=new Tab(tab,"carte");
-        map=new Map(map_tab->NewRow(),"map");
-            map->AddPoint(position,"drone");
-}
-
-DataPlot1D* Gps::EPlot(void) const
-{
-    if((NMEAFlags&GGA)!=0)
-    {
-        return e_plot;
-    }
-    else
-    {
-        Err("GGA sentence not requested\n");
-        return NULL;
-    }
-}
-
-DataPlot1D* Gps::NPlot(void) const
-{
-    if((NMEAFlags&GGA)!=0)
-    {
-        return n_plot;
-    }
-    else
-    {
-        Err("GGA sentence not requested\n");
-        return NULL;
-    }
-}
-
-DataPlot1D* Gps::UPlot(void) const
-{
-    if((NMEAFlags&GGA)!=0)
-    {
-        return u_plot;
-    }
-    else
-    {
-        Err("GGA sentence not requested\n");
-        return NULL;
-    }
-}
-
-DataPlot1D* Gps::VEPlot(void) const
-{
-    if((NMEAFlags&VTG)!=0)
-    {
-        return ve_plot;
-    }
-    else
-    {
-        Err("GGA sentence not requested\n");
-        return NULL;
-    }
-}
-
-DataPlot1D* Gps::VNPlot(void) const
-{
-    if((NMEAFlags&VTG)!=0)
-    {
-        return vn_plot;
-    }
-    else
-    {
-        Err("GGA sentence not requested\n");
-        return NULL;
-    }
-}
-
-Layout* Gps::GetLayout(void) const
-{
-    return sensor_tab;
-}
-
-Tab* Gps::GetPlotTab(void) const
-{
-    return plot_tab;
-}
-
-TabWidget* Gps::GetTab(void) const
-{
-    return tab;
-}
-
-uint16_t Gps::NbSat(void) const
-{
-    output->GetMutex();
-    uint16_t result=nb_sat;
-    output->ReleaseMutex();
-    return result;
-}
-
-Gps::FixQuality_t Gps::FixQuality(void) const
-{
-    output->GetMutex();
-    FixQuality_t result=fix;
-    output->ReleaseMutex();
-    return result;
-}
-
-void Gps::SetRef(void)
-{
-    take_ref=true;
-}
-
-void Gps::GetENUPosition(Vector3D *point)
-{
-    output->GetMutex();
-    point->x=output->ValueNoMutex(0,0);
-    point->y=output->ValueNoMutex(1,0);
-    point->z=output->ValueNoMutex(2,0);
-    output->ReleaseMutex();
-}
-
-void Gps::parseFrame(const char *frame, int frame_size){
-
-    int result;
-
-    result=nmea_parse(&parser, frame, frame_size, &info);
-    if(result!=1)
-    {
-        Warn("unrecognized nmea sentence\n");
-        Warn("%s\n",frame);
-    }
-
-    result=nmea_parse_GPGGA(frame, frame_size, &pack);
-
-    if(result==1)
-    {
-        //Printf("%s\n",frame);
-        //Printf("nb:%i fix:%i lat:%f long:%f alt:%f vel:%f angle:%f\n",pack.satinuse,pack.sig,info.lat,info.lon,info.elv,info.speed*1000./3600.,info.direction);
-        //Printf("lat:%f long:%f\n",pos.lat,pos.lon);
-        output->GetMutex();//on utilise le mutex de l'output pour fix et nb_sat
-        if((int)fix!=pack.sig)
-        {
-            fix=(FixQuality_t)pack.sig;
-            fix_label->SetText("fix: %i",fix);
-        }
-        if(nb_sat!=pack.satinuse)
-        {
-            nb_sat=pack.satinuse;
-            nb_sat_label->SetText("nb_sat: %i",nb_sat);
-        }
-        output->ReleaseMutex();
-
-
-        nmea_info2pos(&info,&pos);
-        position->SetCoordinates(Euler::ToDegree(pos.lat),Euler::ToDegree(pos.lon),info.elv);
-
-        if((info.sig==2 && alt_ref==0) || button_ref->Clicked()==true || take_ref==true)
-        {
-            Printf("prise pos ref\n");
-            lat_ref=pos.lat;
-            long_ref=pos.lon;
-            alt_ref=info.elv;
-            take_ref=false;
-        }
-        //if(alt_ref!=0)
-        {
-            double x,y,z;
-            double e,n,u;
-            Geographique_2_ECEF(pos.lon,pos.lat,info.elv,x,y,z);
-            ECEF_2_ENU(x,y,z,e, n, u,long_ref,lat_ref,alt_ref);
-            //Printf("lon:%f lat:%f elv:%f\n",pos.lon,pos.lat,info.elv);
-
-            //on prend une fois pour toute le mutex et on fait des accès directs
-            output->GetMutex();
-            output->SetValueNoMutex( 0, 0,e);
-            output->SetValueNoMutex( 1, 0,n);
-            output->SetValueNoMutex( 2, 0,u);
-
-            int index=3;
-            if((NMEAFlags&VTG)!=0)
-            {
-                output->SetValueNoMutex( index, 0,info.speed*1000./3600.*sin(Euler::ToRadian(info.direction)));
-                output->SetValueNoMutex( index+1, 0,info.speed*1000./3600.*cos(Euler::ToRadian(info.direction)));
-                index+=2;
-            }
-            if((NMEAFlags&GST)!=0)
-            {
-                //Thread::Printf("dev_lon:%f dev_lat:%f dev_elv:%f\n",info.dev_lat,info.dev_lon,info.dev_elv);
-                output->SetValueNoMutex( index, 0,info.dev_lat);
-                output->SetValueNoMutex( index+1, 0,info.dev_lon);
-                output->SetValueNoMutex( index+2, 0,info.dev_elv);
-                index+=3;
-            }
-            output->ReleaseMutex();
-
-            output->SetDataTime(GetTime());
-            ProcessUpdate(output);
-        }
-    }
+      double x, y, z;
+      double e, n, u;
+      Geographique_2_ECEF(pos.lon, pos.lat, info.elv, x, y, z);
+      ECEF_2_ENU(x, y, z, e, n, u, long_ref, lat_ref, alt_ref);
+      // Printf("lon:%f lat:%f elv:%f\n",pos.lon,pos.lat,info.elv);
+
+      // on prend une fois pour toute le mutex et on fait des accès directs
+      output->GetMutex();
+      output->SetValueNoMutex(0, 0, e);
+      output->SetValueNoMutex(1, 0, n);
+      output->SetValueNoMutex(2, 0, u);
+
+      int index = 3;
+      if ((NMEAFlags & VTG) != 0) {
+        output->SetValueNoMutex(index, 0,
+                                info.speed * 1000. / 3600. *
+                                    sin(Euler::ToRadian(info.direction)));
+        output->SetValueNoMutex(index + 1, 0,
+                                info.speed * 1000. / 3600. *
+                                    cos(Euler::ToRadian(info.direction)));
+        index += 2;
+      }
+      if ((NMEAFlags & GST) != 0) {
+        // Thread::Printf("dev_lon:%f dev_lat:%f
+        // dev_elv:%f\n",info.dev_lat,info.dev_lon,info.dev_elv);
+        output->SetValueNoMutex(index, 0, info.dev_lat);
+        output->SetValueNoMutex(index + 1, 0, info.dev_lon);
+        output->SetValueNoMutex(index + 2, 0, info.dev_elv);
+        index += 3;
+      }
+      output->ReleaseMutex();
+
+      output->SetDataTime(GetTime());
+      ProcessUpdate(output);
+    }
+  }
 }
 
Index: trunk/lib/FlairSensorActuator/src/Gps.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gps.h	(revision 14)
+++ trunk/lib/FlairSensorActuator/src/Gps.h	(revision 15)
@@ -17,223 +17,218 @@
 #include <nmea/nmea.h>
 
-namespace flair
-{
-    namespace core
-    {
-        class cvmatrix;
-        class FrameworkManager;
-        class GeoCoordinate;
-        class Vector3D;
-    }
-    namespace gui
-    {
-        class Layout;
-        class DataPlot1D;
-        class Tab;
-        class TabWidget;
-        class PushButton;
-        class Map;
-        class Label;
-    }
+namespace flair {
+namespace core {
+class cvmatrix;
+class FrameworkManager;
+class GeoCoordinate;
+class Vector3D;
 }
-
-namespace flair
-{
-namespace sensor
-{
-    /*! \class Gps
-    *
-    * \brief Base class for GPS
-    */
-    class Gps : public core::IODevice
-    {
-        public:
-            /*!
-            \enum FixQuality_t
-            \brief Fix qualty indicators
-            */
-            enum class FixQuality_t {
-                Invalid=0,/*!< invalid */
-                Gps=1,/*!< Gps */
-                DGps=2,/*!< Differential Gps */
-                Pps=3,/*!< Pps */
-                Rtk=4,/*!< RTK */
-                RtkFloat=5,/*!< RTK float */
-                Estimated=6,/*!< Estimated */
-                Manual=7,/*!< Manual */
-                Simulation=8,/*!< Simulation */
-                };
-
-            /*!
-            \enum NMEAFlags_t
-            \brief NMEA flags
-            */
-            enum NMEAFlags_t {
-                GGA=0x01,/*!< GGA */
-                VTG=0x02,/*!< VTG */
-                GST=0x04,/*!< GST */
-                };
-
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Gps.
-            *
-            * \param parent parent
-            * \param name name
-            * \param NMEAFlags NMEA sentances to enable
-            */
-            Gps(const core::FrameworkManager* parent,std::string name,NMEAFlags_t NMEAFlags);
-
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Gps();
-
-            /*!
-            * \brief Use default plot
-            *
-            */
-            void UseDefaultPlot(void);
-
-            /*!
-            * \brief East plot
-            *
-            * \return east plot
-            */
-            gui::DataPlot1D* EPlot(void) const;
-
-            /*!
-            * \brief North plot
-            *
-            * \return north plot
-            */
-            gui::DataPlot1D* NPlot(void) const;
-
-            /*!
-            * \brief Up plot
-            *
-            * \return up plot
-            */
-            gui::DataPlot1D* UPlot(void) const;
-
-            /*!
-            * \brief East velocity plot
-            *
-            * \return east velocity plot
-            */
-            gui::DataPlot1D* VEPlot(void) const;
-
-            /*!
-            * \brief North velocity plot
-            *
-            * \return north velocity plot
-            */
-            gui::DataPlot1D* VNPlot(void) const;
-
-            /*!
-            * \brief Main tab
-            *
-            * \return main tab
-            */
-            gui::TabWidget* GetTab(void) const;
-
-            /*!
-            * \brief Setup Layout
-            *
-            * \return setup Layout
-            */
-            gui::Layout* GetLayout(void) const;
-
-            /*!
-            * \brief Plot tab
-            *
-            * \return plot Tab
-            */
-            gui::Tab* GetPlotTab(void) const;
-
-            /*!
-            * \brief Number of used satellites
-            *
-            * \return number of used satellites
-            */
-            uint16_t NbSat(void) const;
-
-            /*!
-            * \brief Fix Quality
-            *
-            * \return fix quality
-            */
-            FixQuality_t FixQuality(void) const;
-
-            /*!
-            * \brief Set reference for ENU coordinates
-            *
-            * The actual position is used as reference to calculate
-            * ENU coordinates.
-            *
-            * \return fix quality
-            */
-            void SetRef(void);
-
-            /*!
-            * \brief Get ENU position
-            *
-            * \param point to store position
-            */
-            void GetENUPosition(core::Vector3D *point);
-
-        protected:
-            /*!
-            * \brief Parse a NMEA frame
-            *
-            * This function must be called by the reimplemented class. \n
-            * When a frame is parsed, GPS datas are filled.
-            *
-            * \param frame NMEA frame
-            * \param frame_size frame size
-            *
-            */
-            void parseFrame(const char *frame, int frame_size);
-
-            NMEAFlags_t NMEAFlags;
-
-        protected:
-            core::GeoCoordinate *position;
-
-        private:
-            /*!
-            * \brief Update using provided datas
-            *
-            * Reimplemented from IODevice.
-            *
-            * \param data data from the parent to process
-            */
-            void UpdateFrom(const core::io_data *data){};
-
-            gui::Tab *main_tab,*sensor_tab;
-            gui::TabWidget* tab;
-            gui::PushButton *button_ref;
-            gui::DataPlot1D* e_plot;
-            gui::DataPlot1D* n_plot;
-            gui::DataPlot1D* u_plot;
-            gui::DataPlot1D* ve_plot;
-            gui::DataPlot1D* vn_plot;
-            gui::Tab* plot_tab;
-            gui::Map *map;
-            gui::Label *nb_sat_label,*fix_label;
-            uint16_t nb_sat;
-            FixQuality_t fix;
-            bool take_ref;
-            nmeaINFO info;
-            nmeaPARSER parser;
-            nmeaGPGGA pack;
-            nmeaPOS pos;
-            double lat_ref,long_ref,alt_ref;
-
-            //matrix
-            core::cvmatrix *output;
-    };
+namespace gui {
+class Layout;
+class DataPlot1D;
+class Tab;
+class TabWidget;
+class PushButton;
+class Map;
+class Label;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class Gps
+*
+* \brief Base class for GPS
+*/
+class Gps : public core::IODevice {
+public:
+  /*!
+  \enum FixQuality_t
+  \brief Fix qualty indicators
+  */
+  enum class FixQuality_t {
+    Invalid = 0,    /*!< invalid */
+    Gps = 1,        /*!< Gps */
+    DGps = 2,       /*!< Differential Gps */
+    Pps = 3,        /*!< Pps */
+    Rtk = 4,        /*!< RTK */
+    RtkFloat = 5,   /*!< RTK float */
+    Estimated = 6,  /*!< Estimated */
+    Manual = 7,     /*!< Manual */
+    Simulation = 8, /*!< Simulation */
+  };
+
+  /*!
+  \enum NMEAFlags_t
+  \brief NMEA flags
+  */
+  enum NMEAFlags_t {
+    GGA = 0x01, /*!< GGA */
+    VTG = 0x02, /*!< VTG */
+    GST = 0x04, /*!< GST */
+  };
+
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Gps.
+  *
+  * \param parent parent
+  * \param name name
+  * \param NMEAFlags NMEA sentances to enable
+  */
+  Gps(const core::FrameworkManager *parent, std::string name,
+      NMEAFlags_t NMEAFlags);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Gps();
+
+  /*!
+  * \brief Use default plot
+  *
+  */
+  void UseDefaultPlot(void);
+
+  /*!
+  * \brief East plot
+  *
+  * \return east plot
+  */
+  gui::DataPlot1D *EPlot(void) const;
+
+  /*!
+  * \brief North plot
+  *
+  * \return north plot
+  */
+  gui::DataPlot1D *NPlot(void) const;
+
+  /*!
+  * \brief Up plot
+  *
+  * \return up plot
+  */
+  gui::DataPlot1D *UPlot(void) const;
+
+  /*!
+  * \brief East velocity plot
+  *
+  * \return east velocity plot
+  */
+  gui::DataPlot1D *VEPlot(void) const;
+
+  /*!
+  * \brief North velocity plot
+  *
+  * \return north velocity plot
+  */
+  gui::DataPlot1D *VNPlot(void) const;
+
+  /*!
+  * \brief Main tab
+  *
+  * \return main tab
+  */
+  gui::TabWidget *GetTab(void) const;
+
+  /*!
+  * \brief Setup Layout
+  *
+  * \return setup Layout
+  */
+  gui::Layout *GetLayout(void) const;
+
+  /*!
+  * \brief Plot tab
+  *
+  * \return plot Tab
+  */
+  gui::Tab *GetPlotTab(void) const;
+
+  /*!
+  * \brief Number of used satellites
+  *
+  * \return number of used satellites
+  */
+  uint16_t NbSat(void) const;
+
+  /*!
+  * \brief Fix Quality
+  *
+  * \return fix quality
+  */
+  FixQuality_t FixQuality(void) const;
+
+  /*!
+  * \brief Set reference for ENU coordinates
+  *
+  * The actual position is used as reference to calculate
+  * ENU coordinates.
+  *
+  * \return fix quality
+  */
+  void SetRef(void);
+
+  /*!
+  * \brief Get ENU position
+  *
+  * \param point to store position
+  */
+  void GetENUPosition(core::Vector3D *point);
+
+protected:
+  /*!
+  * \brief Parse a NMEA frame
+  *
+  * This function must be called by the reimplemented class. \n
+  * When a frame is parsed, GPS datas are filled.
+  *
+  * \param frame NMEA frame
+  * \param frame_size frame size
+  *
+  */
+  void parseFrame(const char *frame, int frame_size);
+
+  NMEAFlags_t NMEAFlags;
+
+protected:
+  core::GeoCoordinate *position;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  gui::Tab *main_tab, *sensor_tab;
+  gui::TabWidget *tab;
+  gui::PushButton *button_ref;
+  gui::DataPlot1D *e_plot;
+  gui::DataPlot1D *n_plot;
+  gui::DataPlot1D *u_plot;
+  gui::DataPlot1D *ve_plot;
+  gui::DataPlot1D *vn_plot;
+  gui::Tab *plot_tab;
+  gui::Map *map;
+  gui::Label *nb_sat_label, *fix_label;
+  uint16_t nb_sat;
+  FixQuality_t fix;
+  bool take_ref;
+  nmeaINFO info;
+  nmeaPARSER parser;
+  nmeaGPGGA pack;
+  nmeaPOS pos;
+  double lat_ref, long_ref, alt_ref;
+
+  // matrix
+  core::cvmatrix *output;
+};
 } // end namespace sensor
 } // end namespace framewor
Index: trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp	(revision 14)
+++ trunk/lib/FlairSensorActuator/src/Gx3_25_imu.cpp	(revision 15)
@@ -25,28 +25,30 @@
 using namespace flair::core;
 
-namespace flair { namespace sensor {
+namespace flair {
+namespace sensor {
 
-Gx3_25_imu::Gx3_25_imu(const FrameworkManager* parent,string name,SerialPort* serialport,Command_t command,uint8_t priority) : Imu(parent,name),Thread(parent,name,priority) {
-    pimpl_=new Gx3_25_imu_impl(this,name,serialport,command,GetGroupBox());
+Gx3_25_imu::Gx3_25_imu(const FrameworkManager *parent, string name,
+                       SerialPort *serialport, Command_t command,
+                       uint8_t priority)
+    : Imu(parent, name), Thread(parent, name, priority) {
+  pimpl_ = new Gx3_25_imu_impl(this, name, serialport, command, GetGroupBox());
 
-    if(command==EulerAnglesAndAngularRates) {
+  if (command == EulerAnglesAndAngularRates) {
 
-    } else if(command==AccelerationAngularRateAndOrientationMatrix) {
-        Thread::Err("oneaxis rotation of rotation matrix is not yet implemented\n");
-    } else {
-        Thread::Err("command not supported (%i)\n",command);
-    }
-    //AddDataToLog(imudata);
+  } else if (command == AccelerationAngularRateAndOrientationMatrix) {
+    Thread::Err("oneaxis rotation of rotation matrix is not yet implemented\n");
+  } else {
+    Thread::Err("command not supported (%i)\n", command);
+  }
+  // AddDataToLog(imudata);
 }
 
 Gx3_25_imu::~Gx3_25_imu() {
-    SafeStop();
-    Join();
-    delete pimpl_;
+  SafeStop();
+  Join();
+  delete pimpl_;
 }
 
-void Gx3_25_imu::Run(void) {
-    pimpl_->Run();
-}
+void Gx3_25_imu::Run(void) { pimpl_->Run(); }
 
 } // end namespace sensor
Index: trunk/lib/FlairSensorActuator/src/Gx3_25_imu.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/Gx3_25_imu.h	(revision 14)
+++ trunk/lib/FlairSensorActuator/src/Gx3_25_imu.h	(revision 15)
@@ -18,69 +18,72 @@
 
 namespace flair {
-    namespace core {
-        class FrameworkManager;
-        class SerialPort;
-    }
+namespace core {
+class FrameworkManager;
+class SerialPort;
+}
 }
 
 class Gx3_25_imu_impl;
 
-namespace flair { namespace sensor {
-    /*! \class Gx3_25_imu
-    *
-    * \brief Class for 3dmgx3-25 Imu
-    */
-    class Gx3_25_imu : public Imu, public core::Thread {
-        friend class ::Gx3_25_imu_impl;
+namespace flair {
+namespace sensor {
+/*! \class Gx3_25_imu
+*
+* \brief Class for 3dmgx3-25 Imu
+*/
+class Gx3_25_imu : public Imu, public core::Thread {
+  friend class ::Gx3_25_imu_impl;
 
-        public:
-            /*!
-            \enum Command_t
-            \brief Command for the continuous mode
-            */
-            enum Command_t{
-                EulerAnglesAndAngularRates=0xcf,/*!< Euler angles and angular rates */
-                AccelerationAngularRateAndOrientationMatrix=0xc8,/*!< Acceleration, angular rate and orientation matrix */
-                };
+public:
+  /*!
+  \enum Command_t
+  \brief Command for the continuous mode
+  */
+  enum Command_t {
+    EulerAnglesAndAngularRates = 0xcf, /*!< Euler angles and angular rates */
+    AccelerationAngularRateAndOrientationMatrix =
+        0xc8, /*!< Acceleration, angular rate and orientation matrix */
+  };
 
-            /*!
-            * \brief Constructor
-            *
-            * Construct a Gx3_25_imu.
-            *
-            * \param parent parent
-            * \param name name
-            * \param serialport SerialPort
-            * \param command command for continuous mode
-            * \param priority priority of the Thread
-            */
-            Gx3_25_imu(const core::FrameworkManager* parent,std::string name,core::SerialPort *serialport,Command_t command,uint8_t priority);
+  /*!
+  * \brief Constructor
+  *
+  * Construct a Gx3_25_imu.
+  *
+  * \param parent parent
+  * \param name name
+  * \param serialport SerialPort
+  * \param command command for continuous mode
+  * \param priority priority of the Thread
+  */
+  Gx3_25_imu(const core::FrameworkManager *parent, std::string name,
+             core::SerialPort *serialport, Command_t command, uint8_t priority);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~Gx3_25_imu();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~Gx3_25_imu();
 
-        private:
-            /*!
-            * \brief Run function
-            *
-            * Reimplemented from Thread.
-            *
-            */
-            void Run(void);
+private:
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
 
-            /*!
-            * \brief Update using provided datas
-            *
-            * Reimplemented from IODevice.
-            *
-            * \param data data from the parent to process
-            */
-            void UpdateFrom(const core::io_data *data){};
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
 
-            class Gx3_25_imu_impl* pimpl_;
-    };
+  class Gx3_25_imu_impl *pimpl_;
+};
 } // end namespace sensor
 } // end namespace flair
